// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.9
// source: proto/master/catalog/transport.proto

package catalog

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// TransportServiceClient is the client API for TransportService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type TransportServiceClient interface {
	CreateTransport(ctx context.Context, in *CreateTransportRequest, opts ...grpc.CallOption) (*Transport, error)
	UpdateTransport(ctx context.Context, in *UpdateTransportRequest, opts ...grpc.CallOption) (*Transport, error)
	DeleteTransport(ctx context.Context, in *TransportIdentifierRequest, opts ...grpc.CallOption) (*DeleteTransportResponse, error)
	GetTransportByID(ctx context.Context, in *TransportIdentifierRequest, opts ...grpc.CallOption) (*Transport, error)
	GetListTransport(ctx context.Context, in *TransportFilterQuery, opts ...grpc.CallOption) (*ListTransport, error)
}

type transportServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewTransportServiceClient(cc grpc.ClientConnInterface) TransportServiceClient {
	return &transportServiceClient{cc}
}

func (c *transportServiceClient) CreateTransport(ctx context.Context, in *CreateTransportRequest, opts ...grpc.CallOption) (*Transport, error) {
	out := new(Transport)
	err := c.cc.Invoke(ctx, "/master.catalog.TransportService/CreateTransport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transportServiceClient) UpdateTransport(ctx context.Context, in *UpdateTransportRequest, opts ...grpc.CallOption) (*Transport, error) {
	out := new(Transport)
	err := c.cc.Invoke(ctx, "/master.catalog.TransportService/UpdateTransport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transportServiceClient) DeleteTransport(ctx context.Context, in *TransportIdentifierRequest, opts ...grpc.CallOption) (*DeleteTransportResponse, error) {
	out := new(DeleteTransportResponse)
	err := c.cc.Invoke(ctx, "/master.catalog.TransportService/DeleteTransport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transportServiceClient) GetTransportByID(ctx context.Context, in *TransportIdentifierRequest, opts ...grpc.CallOption) (*Transport, error) {
	out := new(Transport)
	err := c.cc.Invoke(ctx, "/master.catalog.TransportService/GetTransportByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transportServiceClient) GetListTransport(ctx context.Context, in *TransportFilterQuery, opts ...grpc.CallOption) (*ListTransport, error) {
	out := new(ListTransport)
	err := c.cc.Invoke(ctx, "/master.catalog.TransportService/GetListTransport", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// TransportServiceServer is the server API for TransportService service.
// All implementations must embed UnimplementedTransportServiceServer
// for forward compatibility
type TransportServiceServer interface {
	CreateTransport(context.Context, *CreateTransportRequest) (*Transport, error)
	UpdateTransport(context.Context, *UpdateTransportRequest) (*Transport, error)
	DeleteTransport(context.Context, *TransportIdentifierRequest) (*DeleteTransportResponse, error)
	GetTransportByID(context.Context, *TransportIdentifierRequest) (*Transport, error)
	GetListTransport(context.Context, *TransportFilterQuery) (*ListTransport, error)
	mustEmbedUnimplementedTransportServiceServer()
}

// UnimplementedTransportServiceServer must be embedded to have forward compatible implementations.
type UnimplementedTransportServiceServer struct {
}

func (UnimplementedTransportServiceServer) CreateTransport(context.Context, *CreateTransportRequest) (*Transport, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateTransport not implemented")
}
func (UnimplementedTransportServiceServer) UpdateTransport(context.Context, *UpdateTransportRequest) (*Transport, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateTransport not implemented")
}
func (UnimplementedTransportServiceServer) DeleteTransport(context.Context, *TransportIdentifierRequest) (*DeleteTransportResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteTransport not implemented")
}
func (UnimplementedTransportServiceServer) GetTransportByID(context.Context, *TransportIdentifierRequest) (*Transport, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetTransportByID not implemented")
}
func (UnimplementedTransportServiceServer) GetListTransport(context.Context, *TransportFilterQuery) (*ListTransport, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetListTransport not implemented")
}
func (UnimplementedTransportServiceServer) mustEmbedUnimplementedTransportServiceServer() {}

// UnsafeTransportServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to TransportServiceServer will
// result in compilation errors.
type UnsafeTransportServiceServer interface {
	mustEmbedUnimplementedTransportServiceServer()
}

func RegisterTransportServiceServer(s grpc.ServiceRegistrar, srv TransportServiceServer) {
	s.RegisterService(&TransportService_ServiceDesc, srv)
}

func _TransportService_CreateTransport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateTransportRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransportServiceServer).CreateTransport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TransportService/CreateTransport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransportServiceServer).CreateTransport(ctx, req.(*CreateTransportRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransportService_UpdateTransport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateTransportRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransportServiceServer).UpdateTransport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TransportService/UpdateTransport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransportServiceServer).UpdateTransport(ctx, req.(*UpdateTransportRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransportService_DeleteTransport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TransportIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransportServiceServer).DeleteTransport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TransportService/DeleteTransport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransportServiceServer).DeleteTransport(ctx, req.(*TransportIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransportService_GetTransportByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TransportIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransportServiceServer).GetTransportByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TransportService/GetTransportByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransportServiceServer).GetTransportByID(ctx, req.(*TransportIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransportService_GetListTransport_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(TransportFilterQuery)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransportServiceServer).GetListTransport(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.catalog.TransportService/GetListTransport",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransportServiceServer).GetListTransport(ctx, req.(*TransportFilterQuery))
	}
	return interceptor(ctx, in, info, handler)
}

// TransportService_ServiceDesc is the grpc.ServiceDesc for TransportService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var TransportService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "master.catalog.TransportService",
	HandlerType: (*TransportServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateTransport",
			Handler:    _TransportService_CreateTransport_Handler,
		},
		{
			MethodName: "UpdateTransport",
			Handler:    _TransportService_UpdateTransport_Handler,
		},
		{
			MethodName: "DeleteTransport",
			Handler:    _TransportService_DeleteTransport_Handler,
		},
		{
			MethodName: "GetTransportByID",
			Handler:    _TransportService_GetTransportByID_Handler,
		},
		{
			MethodName: "GetListTransport",
			Handler:    _TransportService_GetListTransport_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/master/catalog/transport.proto",
}
